Educational Codeforces Round 114 (Rated for Div. 2) D.The Strongest Buil(暴力)

2023-12-13 01:30

本文主要是介绍Educational Codeforces Round 114 (Rated for Div. 2) D.The Strongest Buil(暴力),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

1.题目链接:https://codeforces.com/contest/1574/problem/D
2.题意:一个人他穿装备,有 n n n个部位可以穿。第 i i i个部位有 c i c_i ci件装备可以选择,加的属性是 a [ i ] [ c i ] a[i][c_i] a[i][ci](每个部位的装备属性按从小到大排列),有 m m m种装备组合是被ban掉不能使用的。现在让你找出最大属性和的装备组合。
3.思路:考虑暴力搜索:
对于第一个样例:
在这里插入图片描述
我们可以得到这样一颗搜索树:
在这里插入图片描述
首先发现有许多状态是重复的,可以DP或者记忆化搜索,但是这样做并不能让搜索空间缩小的可以接受的范围内。所以得考虑其他性质,我们发现在搜索树上父节点对应得属性和一定大于所有儿子节点(包括儿子的儿子…)的属性,所以我们如果搜过了父亲,就不用去管儿子节点了。这样我们的思路就出来了,在BFS的过程中,只加入父节点被BAN掉的子节点,这样就可以保证在可以接受的范围内找到最合适的答案了。判重的话可以哈希(没试过),我这里用的set(用set还错了好几次)(map也可以)。
4.代码:

#include<bits/stdc++.h>
using namespace std;
const int N=2e5+7;
struct node{int p[10];//乱写的,保证set中不会把两个不同元素判成相同即可bool operator<(const node b)const{for(int i=0;i<10;i++){if(this->p[i]!=b.p[i]) return this->p[i]<b.p[i];}return 0;}
};
int a[17][N];
node b;
set<node> se,ed;
int main()
{int n;scanf("%d",&n);for(int i=0;i<n;i++){int k;scanf("%d",&k);b.p[i]=k;for(int j=1;j<=k;j++) scanf("%d",&a[i][j]);}for(int i=n;i<10;i++) b.p[i]=0;int m;scanf("%d",&m);for(int i=0;i<m;i++){node s;for(int i=0;i<n;i++){int temp;scanf("%d",&temp);s.p[i]=temp;}for(int i=n;i<10;i++) s.p[i]=0;se.insert(s);}queue<node> q;q.push(b);node ans;int ma=0;while(!q.empty()){node t=q.front();q.pop();//记忆化if(ed.count(t)!=0) continue;ed.insert(t);//遍历//如果没有被banif(se.count(t)==0){int now=0;for(int i=0;i<n;i++){int x=t.p[i];now+=a[i][x];}
//			for(int i=0;i<n;i++) printf("abc%d ",t.p[i]);
//			printf("%d\n",now);if(now>ma){ma=now;for(int i=0;i<n;i++) ans.p[i]=t.p[i];}}//被ban了就把儿子加入else{for(int i=0;i<n;i++){if(t.p[i]!=0&&t.p[i]!=1){t.p[i]--;q.push(t);t.p[i]++;}}}}for(int i=0;i<n;i++){printf("%d ",ans.p[i]);}printf("\n");
}

这篇关于Educational Codeforces Round 114 (Rated for Div. 2) D.The Strongest Buil(暴力)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/486670

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

计蒜客 Half-consecutive Numbers 暴力打表找规律

The numbers 11, 33, 66, 1010, 1515, 2121, 2828, 3636, 4545 and t_i=\frac{1}{2}i(i+1)t​i​​=​2​​1​​i(i+1), are called half-consecutive. For given NN, find the smallest rr which is no smaller than NN

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

10125-Sumsets【暴力】

利用n^2的时间枚举所有a[i] + a[j] 利用n^2的时间枚举所有a[i] - a[j] 之后利用n^2时间一个一个找a[i] - a[j]的值是否存在于a[i] + a[j]中 找的时候需要二分查找 另外一点就是注意long long的范围以及四个数是集合内不同的四个元素 15222638 10125 Sumsets Accepted C++ 0.449 2015-03-